#pragma once
#include <cmath>

inline float finterp_ro_constant(float Current, float Target, float DeltaTime, float InterpSpeed)
{
    // Calculate the distance to target
    float Dist = Target - Current;

    // If the distance is very small or speed is very small, return target
    if (std::abs(Dist) < 1e-6 || std::abs(InterpSpeed) < 1e-6)
    {
        return Target;
    }

    // Calculate the step we can take this frame
    float Step = InterpSpeed * DeltaTime;

    // Clamp the step to the distance to ensure we don't overshoot
    float ClampedStep = std::clamp(Dist, -Step, Step);

    // Return the new interpolated value
    return Current + ClampedStep;
}
